#include<iostream.h>
struct  node
{
  int Key;
  int Count;
  node *Left;
  node *Right;
};

class TREE
{
  private:
    node *Tree; //   .
    void Search (int,node**);
  public:
    TREE() {Tree=NULL;}
    node** GetTree () {return &Tree;} //  .
    void BuildTree ();
    void CleanTree (node **);
    void ObhodEnd (node **);
    void ObhodLeft (node **);
    void ObhodBack (node **);
    void Vyvod (node**,int);
    int Height (node**);
};

void main ()
{
  TREE A;

  A.BuildTree ();
  cout<<"\n :\n";
  A.Vyvod (A.GetTree(),0);
  cout<<"\n :"<<A.Height(A.GetTree())<<endl;
  cout<<"\n  : ";
  A.ObhodLeft (A.GetTree());
  cout<<"\n  : "; A.ObhodEnd (A.GetTree());
  cout<<"\n  : "; A.ObhodBack (A.GetTree());
  A.CleanTree (A.GetTree());
}

void TREE::BuildTree ()
//    ( ).
// Tree -    .
{
  int el;

  cout<<"    ...\n";
  cin>>el;
  while  (el!=0)
  { Search (el,&Tree); cin>>el; }
}

void TREE::Search (int x,node **p)
//      x    
//             ( ).
// *p -    .
{
  if  (*p==NULL)
  {//    ;  .
    *p = new(node);
    (**p).Key = x;     (**p).Count = 1;
    (**p).Left = NULL; (**p).Right = NULL; }
  else
    if  (x<(**p).Key) Search (x,&((**p).Left));
    else
      if  (x>(**p).Key) Search (x,&((**p).Right));
      else  (**p).Count = (**p).Count + 1;
}

void TREE::ObhodLeft (node **w)
//  .
//*w -    .
{
  if  (*w!=NULL)
  {
    cout<<(**w).Key<<" ";
    ObhodLeft (&((**w).Left));
    ObhodLeft (&((**w).Right));
  }
}

void TREE::ObhodEnd (node **w)
//  .
//*w -    .
{
  if  (*w!=NULL)
  { ObhodEnd (&((**w).Left));
    ObhodEnd (&((**w).Right));
    cout<<(**w).Key<<" "; }
}

void TREE::ObhodBack (node **w)
//  .
//*w -    .
{
  if  (*w!=NULL)
  { ObhodBack (&((**w).Left));
    cout<<(**w).Key<<" ";
    ObhodBack (&((**w).Right)); }
}

void TREE::CleanTree (node **w)
// .
//*w -    .
{
  if  (*w!=NULL)
  { CleanTree (&((**w).Left));
    CleanTree (&((**w).Right));
    delete *w; }
}

void TREE::Vyvod (node **w,int l)
//  *w   
//          ( ).
//*w -    .
{
  int i;

  if  (*w!=NULL)
  { Vyvod (&((**w).Right),l+1);
    for  (i=1; i<=l; i++) cout<<"   ";
    cout<<(**w).Key<<endl;
    Vyvod (&((**w).Left),l+1); }
}

int TREE::Height (node **w)
//   .
//*w -    .
{
  int h1,h2;
  if  (*w==NULL) return (-1);
  else
  {
    h1 = Height (&((**w).Left));
    h2 = Height (&((**w).Right));
    if  (h1>h2) return (1 + h1);
    else  return (1 + h2);
  }
}
